<?php
/** 
* Polish Language File developed by mybboard.pl for MyBBpublisher 1.6.2
* Tłumaczenie: Schocker
* Poprawki: Ekipa Polskiego Supportu MyBB (mybboard.pl)
* Wersja 1.0
**/ 

/**
 * MyBBpublisher v 1.6.2
 * Copyright � 2011 Jason Bryngelson
 *
 * Website: http://www.pavementsucks.com/board/misc.php?page=plugins
 * License: Creative Commons Attribution-NonCommerical ShareAlike 3.0
			http://creativecommons.org/licenses/by-nc-sa/3.0/legalcode *
 *
 */
 
// Disallow direct access to this file for security reasons DO NOT REMOVE
if(!defined("IN_MYBB"))
{
	die("Direct initialization of this file is not allowed.<br /><br />Please make sure IN_MYBB is defined.<br />");
}

/****************************************************************
Hook code
****************************************************************/
//handle new threads generated via post datahandler
// - have to use post version as tid not availble until this hook
$plugins->add_hook("datahandler_post_insert_thread_post", "mybbpublisher_newthread");

//handle deleted threads
$plugins->add_hook("class_moderation_delete_thread_start", "mybbpublisher_delthread");

//handle editted threads
$plugins->add_hook("datahandler_post_update_thread", "mybbpublisher_editthread");

//handle moved threads (move single, move multiple, w/ and w/o redirects
$plugins->add_hook("class_moderation_move_thread_redirect", "mybbpublisher_onmove");
$plugins->add_hook("class_moderation_move_simple", "mybbpublisher_onmove");
$plugins->add_hook("class_moderation_move_threads", "mybbpublisher_onmove");

//handle thread moderation (approval only)
$plugins->add_hook("class_moderation_approve_threads", "mybbpublisher_approvethreads");

//handle announcements
$plugins->add_hook("admin_forum_announcements_add_commit", "mybbpublisher_onannounce");
$plugins->add_hook("admin_forum_announcements_edit_commit", "mybbpublisher_onannounce");
$plugins->add_hook("admin_forum_announcements_delete", "mybbpublisher_delannounce");
 
//handle icon to indicate forum is published
$plugins->add_hook("build_forumbits_forum", "mybbpublisher_addicon");

//handle settings change to prompt user after save
$plugins->add_hook("admin_config_settings_change_commit", "mybbpublisher_fb_prompt");
$plugins->add_hook("admin_config_settings_edit_commit", "mybbpublisher_fb_prompt");

//redirect to settings once activated
$plugins->add_hook("admin_config_plugins_activate_commit", "mybbpublisher_settings_redirect");

//handle testing items
$plugins->add_hook("admin_tools_menu", "mybbpublisher_admin_nav");
$plugins->add_hook("admin_tools_action_handler", "mybbpublisher_action_handler");
$plugins->add_hook("admin_load", "mybbpublisher_admin");


/****************************************************************
Install code
****************************************************************/
function mybbpublisher_info()
{
	return array(
		"name"		=> "MyBBpublisher",
		"description"	=> "Publikuje treści z forum na wybranych portalach społecznościowych.",
		"website"	=> "http://www.pavementsucks.com/board/misc.php?page=plugins",
		"author"	=> "PavementSucks.com",
		"authorsite"	=> "http://www.pavementsucks.com/board/misc.php?page=plugins",
		"version"	=> "1.6.2",
		"guid" 		=> "7c8931b891567c13d1e05534ac50dd52",
		"compatibility" => "14*,16*"
	);
}

function mybbpublisher_install() 
{
	global $mybb, $db;
    
    //get current version if avail
    $oldver = mybbpublisher_get_cache_version() ;
        
    //start settings install
	$settings_group = array(
		"gid" => "",
		"name" => "MyBBpublisher",
		"title" => "MyBBpublisher",
		"description" => "Ustawienia pluginu MyBBpublisher.",
		"disporder" => "50",
		"isdefault" => "0",
        );
		
	$db->insert_query("settinggroups", $settings_group);
	$gid = $db->insert_id();
	
	$pluginsetting = array();
	
	$disporder = 1;
	
	$pluginsetting[] = array(
		"name"		=> "mybbpublisher_enabled",
		"title"		=> "Włącz MyBBpublisher",
		"description"	=> "Główny przełącznik pluginu MyBBpublisher.",
		"optionscode"	=> "onoff",
		"value"		=> "0",
		"disporder"	=> $disporder,
		"gid"		=> $gid
	);
	
	$pluginsetting[] = array(
		"name"		=> "mybbpublisher_inclusive",
		"title"		=> "Czy używać poniższej listy ID działów jako białej listy?",
		"description"	=> "Jeśli ustawione na {yes}, zawartość będzie publikowana tylko z działów o podanych ID (biała lista). Jeśli ustawione na {no}, zawartość będzie publikowana z wszystkich działów oprócz wymienionych poniżej (czarna lista).",
		"optionscode"	=> "yesno",
		"value"		=> "1",
		"disporder"	=> ++$disporder,
		"gid"		=> $gid
	);
	
	$pluginsetting[] = array(
		"name"		=> "mybbpublisher_forums",
		"title"		=> "Działy, z których mają być publikowane nowe wątki",
		"description"	=> "To jest lista (w formacie CSV) ID działów, z których będzie publikowana zawartość (jeśli powyższa opcja jest ustawiona na Tak), lub z których nie będzie ona publikowana (jeśli powyższa opcja jest ustawiona na Nie). Wpisz 0, aby wyłączyć lub włączyć publikowanie ze wszystkich działów. <br /><font color=\"red\">Bądź ostrożny, inaczej mogą być udostępniane wątki z działów prywatnych.</font>",
		"optionscode"	=> "text",
		"value"		=> "",
		"disporder"	=> ++$disporder,
		"gid"		=> $gid
	);
	
	$pluginsetting[] = array(
		"name"		=> "mybbpublisher_onnewthread",
		"title"		=> "Publikować tytuły nowych wątków?",
		"description"	=> "Publikować tytuły nowych wątków z działów o podanych wyżej ID?",
		"optionscode"	=> "yesno",
		"value"		=> "0",
		"disporder"	=> ++$disporder,
		"gid"		=> $gid
	);
	
	$pluginsetting[] = array(
		"name"		=> "mybbpublisher_onannounce",
		"title"		=> "Publikować ogłoszenia?",
		"description"	=> "Publikowanie nowych ogłoszeń. Działa tylko dla ogłoszeń utworzonych bądź zmienionych przez ACP, a nie MCP.",
		"optionscode"	=> "yesno",
		"value"		=> "0",
		"disporder"	=> ++$disporder,
		"gid"		=> $gid
	);

	
	$pluginsetting[] = array(
		"name"		=> "mybbpublisher_onmove",
		"title"		=> "Udostępniać przeniesione wątki?",
		"description"	=> "Jeśli wątek zostaje przeniesiony do jednego z działów, których ID są podane powyżej, czy opublikować go? Nie działa przy kopiowaniu wątków, tylko przy przenoszeniu (również z przekierowaniem).",
	        "optionscode" 	=> "yesno",
	        "value" 	=> "0",
		"disporder"	=> ++$disporder,
		"gid"		=> $gid
	);

	
	$pluginsetting[] = array(
		"name"		=> "mybbpublisher_tw_enabled",
		"title"		=> "Umieszczać w serwisie Twitter?",
		"description"	=> "Włącz publikowanie w serwisie Twitter.",
		"optionscode"	=> "yesno",
		"value"		=> "0",
		"disporder"	=> ++$disporder,
		"gid"		=> $gid
	);

		
	$pluginsetting[] = array(
		"name"		=> "mybbpublisher_tw_username",
		"title"		=> "Twitter: nazwa użytkownika",
		"description"	=> "Dane z serwisu Twitter Twoja nazwa użytkownika, bez @ na poczatku.",
		"optionscode"	=> "text",
		"value"		=> "",
		"disporder"	=> ++$disporder,
		"gid"		=> $gid
	);	

		
	$pluginsetting[] = array(
		"name"		=> "mybbpublisher_tw_ckey",
		"title"		=> "Twitter: klucz konsumenta",
		"description"	=> "Dane z serwisu Twitter: Klucz konsumenta (consumer key) twojej aplikacji, tworzony na stronie <a href=\"http://twitter.com/apps/new\" target=\"_blank\">http://twitter.com/apps/new</a>.",
		"optionscode"	=> "text",
		"value"		=> "",
		"disporder"	=> ++$disporder,
		"gid"		=> $gid
	);

		
	$pluginsetting[] = array(
		"name"		=> "mybbpublisher_tw_csecret",
		"title"		=> "Twitter: sekretne hasło konsumenta",
		"description"	=> "Dane z serwisu Twitter: Sekretne hasło konsumenta (consumer secret) twojej aplikacji, tworzone na stronie <a href=\"http://twitter.com/apps/new\" target=\"_blank\">http://twitter.com/apps/new</a>.",
		"optionscode"	=> "text",
		"value"		=> "",
		"disporder"	=> ++$disporder,
		"gid"		=> $gid
	);

		
	$pluginsetting[] = array(
		"name"		=> "mybbpublisher_tw_token",
		"title"		=> "Twitter: token dostępu",
		"description"	=> "Dane z serwisu Twitter: Token dostępu (access token) do konta, na którym będą publikowane zmiany statusu (dostępny na stronie https://dev.twitter.com/apps/<id_aplikacji>/my_token ).",
		"optionscode"	=> "text",
		"value"		=> "",
		"disporder"	=> ++$disporder,
		"gid"		=> $gid
	);

		
	$pluginsetting[] = array(
		"name"		=> "mybbpublisher_tw_secret",
		"title"		=> "Twitter: sekretne hasło tokenu dostępu",
		"description"	=> "Dane z serwisu Twitter: Sekretne hasło tokenu dostępu (access token secret) do konta, na którym będą publikowane zmiany statusu (dostępne na stronie https://dev.twitter.com/apps/<id_aplikacji>/my_token ).",
		"optionscode"	=> "text",
		"value"		=> "",
		"disporder"	=> ++$disporder,
		"gid"		=> $gid
	);

		
	$pluginsetting[] = array(
		"name"		=> "mybbpublisher_tw_icon",
		"title"		=> "Twitter: ścieżka dostępu do ikony",
		"description"	=> "Względna ścieżka dostępu do ikony, która będzie pokazywana przy działach, w których jest włączone publikowanie w serwisie Twitter. Pozostaw to pole puste, aby nie pokazywać ikony.",
		"optionscode"	=> "text",
		"value"		=> "images/twitter_icon.png",
		"disporder"	=> ++$disporder,
		"gid"		=> $gid
	);

		
	$pluginsetting[] = array(
		"name"		=> "mybbpublisher_tw_hashtags",
		"title"		=> "Twitter: hasztagi",
		"description"	=> "To jest lista (w formacie CSV) wyrażeń, którymi mają być oznaczone wpisy (# zostanie automatycznie dodany). Posortuj je zgodnie z ważnością, jako że ilość hasztagów jest ograniczona do liczby podanej poniżej.",
		"optionscode"	=> "text",
		"value"		=> "",
		"disporder"	=> ++$disporder,
		"gid"		=> $gid
	);

		
	$pluginsetting[] = array(
		"name"		=> "mybbpublisher_tw_hashlimit",
		"title"		=> "Twitter: limit hasztagów",
		"description"	=> "Maksymalna ilość hasztagów, jakimi może być oznaczony wpis. Wpisz 0, aby wyłączyć hasztagi.",
		"optionscode"	=> "text",
		"value"		=> "0",
		"disporder"	=> ++$disporder,
		"gid"		=> $gid
	);

		
	$pluginsetting[] = array(
		"name"		=> "mybbpublisher_fb_enabled",
		"title"		=> "Umieszczać w serwisie Facebook?",
		"description"	=> "Włącz publikowanie w serwisie Facebook.",
		"optionscode"	=> "yesno",
		"value"		=> "0",
		"disporder"	=> ++$disporder,
		"gid"		=> $gid
	);

		
	$pluginsetting[] = array(
		"name"		=> "mybbpublisher_fb_appid",
		"title"		=> "Facebook: ID aplikacji",
		"description"	=> "Dane z serwisu Facebook: numer ID aplikacji, tworzony na stronie <a href=\"http://www.facebook.com/developers/createapp.php\" target=\"_blank\">http://www.facebook.com/developers/createapp.php</a>.",
		"optionscode"	=> "text",
		"value"		=> "",
		"disporder"	=> ++$disporder,
		"gid"		=> $gid
	);

		
	$pluginsetting[] = array(
		"name"		=> "mybbpublisher_fb_apikey",
		"title"		=> "Facebook: klucz aplikacji",
		"description"	=> "Dane z serwisu Facebook: klucz API Twojej aplikacji, tworzony na stronie http://www.facebook.com/developers/apps.php?app_id=<id_aplikacji>.",
		"optionscode"	=> "text",
		"value"		=> "",
		"disporder"	=> ++$disporder,
		"gid"		=> $gid
	);

		
	$pluginsetting[] = array(
		"name"		=> "mybbpublisher_fb_secret",
		"title"		=> "Facebook: sekretne hasło aplikacji",
		"description"	=> "Dane z serwisu Facebook: sekretne hasło dla aplikacji, tworzone na stronie http://www.facebook.com/developers/apps.php?app_id=<id_aplikacji>.",
		"optionscode"	=> "text",
		"value"		=> "",
		"disporder"	=> ++$disporder,
		"gid"		=> $gid
	);

	$pluginsetting[] = array(
		"name"		=> "mybbpublisher_fb_access_token",
		"title"		=> "Facebook: token dostępu do osobistego konta",
		"description"	=> "Dane z serwisu Facebook: To jest token osobistego konta w serwisie Facebook.<br /><font color=\"red\">Aby ustawić lub zmienić tą wartość, przejdź do ACP > Narzędzia i konserwacja > MyBB Publisher > Krok 2: Otrzymanie tokenu dostępu do twojego konta na Facebooku..</font>",
		"optionscode"	=> "php",
		"value"		=> "",
		"disporder"	=> ++$disporder,
		"gid"		=> $gid
	);

	$pluginsetting[] = array(
		"name"		=> "mybbpublisher_fb_access_token_page",
		"title"		=> "Facebook: token dostępu do osobistej strony",
		"description"	=> "Dane z serwisu Facebook: To jest token dla strony fanowskiej/grupy/aplikacji którą zarządzasz i która ma być autorem dodawanych postów. Jeśli to pole pozostanie puste, posty będą opublikowane z twojego osobistego konta. <br /><font color=\"red\">Aby ustawić lub zmienić tą wartość, przejdź do ACP > Narzędzia i konserwacja > MyBB Publisher > Krok 2: Otrzymanie tokenu dostępu do twojego konta na Facebooku..</font>",
		"optionscode"	=> "php",
		"value"		=> "",
		"disporder"	=> ++$disporder,
		"gid"		=> $gid
	);
	
	$pluginsetting[] = array(
		"name"		=> "mybbpublisher_fb_pageid",
		"title"		=> "Facebook: ID strony",
		"description"	=> "Dane z serwisu Facebook: To jest tablica strony fanowskiej/grupy/aplikacji którą zarządzasz i na której mają być publikowane posty.<br /><font color=\"red\">Aby ustawić lub zmienić tą wartość, przejdź do ACP > Narzędzia i konserwacja > MyBB Publisher > Krok 3: Wybierz, gdzie wpisy będą dodawane i ich autora.</font>",
		"optionscode"	=> "php",
		"value"		=> "",
		"disporder"	=> ++$disporder,
		"gid"		=> $gid
	);

	$pluginsetting[] = array(
		"name"		=> "mybbpublisher_fb_icon",
		"title"		=> "Facebook: ścieżka do ikony",
		"description"	=> "Względna ścieżka dostępu do ikony, która będzie pokazywana przy działach, w których jest włączone publikowanie w serwisie Facebook. Pozostaw to pole puste, aby nie pokazywać ikony.",
		"optionscode"	=> "text",
		"value"		=> "images/facebook_icon.png",
		"disporder"	=> ++$disporder,
		"gid"		=> $gid
	);

	$pluginsetting[] = array(
		"name"		=> "mybbpublisher_shorten_service",
		"title"		=> "Którego serwisu do skracania adresów URL chcesz używać?",
		"description"	=> "Wybierz serwis do skracania linków, którego chcesz używać. Ten serwis jest używany tylko wtedy, gdy poniższe ustawienia są wypełnione.",
		"optionscode"	=> "radio\r\nbit=Bit.ly\r\nadf=Adf.ly",
		"value"		=> "bit",
		"disporder"	=> ++$disporder,
		"gid"		=> $gid
	);
	
	$pluginsetting[] = array(
		"name"		=> "mybbpublisher_shorten_user",
		"title"		=> "Login do Bit.ly lub ID użytkownika w Adf.ly",
		"description"	=> "Wpisz login lub ID użytkownika z wybranego przez ciebie serwisu skrającego linki.",
		"optionscode"	=> "text",
		"value"		=> "",
		"disporder"	=> ++$disporder,
		"gid"		=> $gid
	);
	
	$pluginsetting[] = array(
		"name"		=> "mybbpublisher_shorten_key",
		"title"		=> "Klucz API z seriwsu bit.ly lub Adf.ly",
		"description"	=> "Wpisz klucz API z wybranego przez ciebie serwisu skracającego linki.",
		"optionscode"	=> "text",
		"value"		=> "",
		"disporder"	=> ++$disporder,
		"gid"		=> $gid
	);	
	
	$pluginsetting[] = array(
		"name"		=> "mybbpublisher_bitly_tw",
		"title"		=> "Używać linków skróconych przez bit.ly w serwisie Twitter?",
		"description"	=> "Czy chcesz skrócić adresy URL (używając swojego konta bit.ly) podczas umieszczania zmian statusu w serwisie Twitter?",
		"optionscode"	=> "yesno",
		"value"		=> "0",
		"disporder"	=> ++$disporder,
		"gid"		=> $gid
	);

	$pluginsetting[] = array(
		"name"		=> "mybbpublisher_bitly_fb",
		"title"		=> "Używać linków skróconych przez bit.ly w serwisie Facebook?",
		"description"	=> "Czy chcesz skrócić adresy URL (używając swojego konta bit.ly) podczas umieszczania zmian statusu na twojej stronie w serwisie Facebook?",
		"optionscode"	=> "yesno",
		"value"		=> "0",
		"disporder"	=> ++$disporder,
		"gid"		=> $gid
	);
	
	$pluginsetting[] = array(
		"name"		=> "mybbpublisher_uninstall_fields",
		"title"		=> "Usunąć ID statusów przy odinstalowywaniu pluginu?",
		"description"	=> "Podczas odinstalowywania pluginu, czy chcesz też usunąć z bazy danych aktualne ID statusów? Ponowne zainstalowanie pluginu nie spowoduje ich nadpisania.",
		"optionscode"	=> "yesno",
		"value"		=> "0",
		"disporder"	=> ++$disporder,
		"gid"		=> $gid
	);

	
	reset($pluginsetting);
	foreach($pluginsetting as $setting)
	{
		$db->insert_query("settings", $setting);
	}
	
	rebuild_settings();

	if(!$db->field_exists('tw_id', 'announcements'))
	{
		$db->write_query("ALTER TABLE ".TABLE_PREFIX."announcements ADD tw_id VARCHAR(20) DEFAULT 0 NOT NULL");
	}
	if(!$db->field_exists('fb_id', 'announcements'))
	{
		$db->write_query("ALTER TABLE ".TABLE_PREFIX."announcements ADD fb_id VARCHAR(50) DEFAULT 0 NOT NULL");
		$db->write_query("ALTER TABLE ".TABLE_PREFIX."announcements ADD fb_uid VARCHAR(50) DEFAULT 0 NOT NULL");
	}
	if(!$db->field_exists('tw_id', 'threads'))
	{
		$db->write_query("ALTER TABLE ".TABLE_PREFIX."threads ADD tw_id VARCHAR(20) DEFAULT 0 NOT NULL");
	}
	if(!$db->field_exists('fb_id', 'threads'))
	{
		$db->write_query("ALTER TABLE ".TABLE_PREFIX."threads ADD fb_id VARCHAR(50) DEFAULT 0 NOT NULL");
		$db->write_query("ALTER TABLE ".TABLE_PREFIX."threads ADD fb_uid VARCHAR(50) DEFAULT 0 NOT NULL");
	}
}


function mybbpublisher_is_installed() 
{
	global $db;
	
	$query = $db->simple_select('settinggroups', 'gid', "name = 'MyBBpublisher'");
	if($db->num_rows($query) > 0)
	{
		return true;
	}
	else
	{
		return false;
	}
}

function mybbpublisher_activate() 
{
    global $mybb, $db, $cache, $lang;
    
    //clear old error cache
    $cache->update('mybbpublisher_errors_tw',false);
    $cache->update('mybbpublisher_errors_fb',false);
    
    //deal with version changes on activate
    $oldver = mybbpublisher_get_cache_version() ;

	if(file_exists(MYBB_ROOT.'/inc/plugins/mybbpublisher/upgrade.php'))
	{
		require_once MYBB_ROOT.'/inc/plugins/mybbpublisher/upgrade.php';
    }
	$retval = mybbpublisher_set_cache_version() ;

 	rebuild_settings();
}

function mybbpublisher_deactivate() 
{

}

function mybbpublisher_uninstall() 
{
	global $mybb, $db, $cache;
	
	if($mybb->settings['mybbpublisher_uninstall_fields'] == 1)
	{
		$db->write_query("ALTER TABLE ".TABLE_PREFIX."announcements DROP tw_id");
		$db->write_query("ALTER TABLE ".TABLE_PREFIX."announcements DROP fb_id");
		$db->write_query("ALTER TABLE ".TABLE_PREFIX."announcements DROP fb_uid");
		$db->write_query("ALTER TABLE ".TABLE_PREFIX."threads DROP tw_id");
		$db->write_query("ALTER TABLE ".TABLE_PREFIX."threads DROP fb_id");
		$db->write_query("ALTER TABLE ".TABLE_PREFIX."threads DROP fb_uid");
	}
	
	$query = $db->simple_select("settinggroups", "gid", "name='mybbpublisher'");
	$gid = $db->fetch_field($query, 'gid');
	$db->delete_query("settinggroups","gid='".$gid."'");
	$db->delete_query("settings", "name like '%mybbpublisher%'");
	
	rebuild_settings();
    
    //remove version details
    $retval = mybbpublisher_unset_cache_version() ;
}

//these 2 functions "borrowed" from MattR
// get the gid of the MyBBPublisher settings group
function mybbpublisher_settings_gid()
{
	global $db;
	
	$query = $db->simple_select("settinggroups", "gid", "name = 'mybbpublisher'", array("limit" => 1));
	$gid = $db->fetch_field($query, "gid");
	
	return intval($gid);
}

// redirect to the settings page after activating
function mybbpublisher_settings_redirect()
{
	global $mybb, $db, $lang, $installed;
	
	if($installed === true && $mybb->input['plugin'] == "mybbpublisher")
	{
		$lang->load("mybbpublisher");
		
		$gid = mybbpublisher_settings_gid();
		
		flash_message($lang->mybbpublisher_activated, 'success');
		admin_redirect("index.php?module=config-settings&action=change&gid={$gid}");
	}
}

/****************************************************************
Versioning code
****************************************************************/
function mybbpublisher_get_cache_version() 
{
	global $cache;

	//get currently installed version, if there is one
	$pscom_plugins = $cache->read('pscom_plugins');
	if(is_array($pscom_plugins))
	{
        	return $pscom_plugins['versions']['mybbpublisher'];
	}
    
    return 0;
}

function mybbpublisher_set_cache_version() 
{
	global $cache;
	
	//get version from this plugin file
	$mybbpublisher_info = mybbpublisher_info();
    
	//update version cache to latest
	$pscom_plugins = $cache->read('pscom_plugins');
	$pscom_plugins['versions']['mybbpublisher'] = $mybbpublisher_info['version'];
	$cache->update('pscom_plugins', $pscom_plugins);

    return true;
}

function mybbpublisher_unset_cache_version() 
{
	global $cache;

	$pscom_plugins = $cache->read('pscom_plugins');
	unset($pscom_plugins['versions']['mybbpublisher']);
	$cache->update('pscom_plugins', $pscom_plugins);
    
    return true;
}

/****************************************************************
General code
****************************************************************/

//test if target FID is in list of forums to include/exclude
function mybbpublisher_can_do_publish($fid) 
{
	global $mybb, $cache;

	//make sure its not a category
	$forumcache = $cache->read('forums');
	if($forumcache[$fid]['type'] == 'c')
	{
		return 0;
	}
	
	//check if fid is visible to guests and registered users
	$groupperms = usergroup_permissions('1,2');
	$forumpermissions=fetch_forum_permissions($fid, '1,2', $groupperms);
	
	if($forumpermissions['canview'] != 1 || $forumpermissions['canviewthreads'] != 1)
	{
		return 0;
	}
	
	$inclusive = $mybb->settings['mybbpublisher_inclusive'];
	
	//init var
	$do_post = ($inclusive == 1 ? 1 : 0);
	
	if($mybb->settings['mybbpublisher_forums'] != "0")
	{
		$forums2send = explode(",", $mybb->settings['mybbpublisher_forums']);
		if(!in_array($fid, $forums2send))
		{
			//change var if condition met
			$do_post = ($inclusive == 1 ? 0 : 1);
		}
	}
	return $do_post;
}

//handle new threads
function mybbpublisher_newthread($threadbyref) 
{
        global $mybb, $db;
	
	//since hook is by ref, put needed data into separate var
	$mythread = $threadbyref->post_insert_data;
	
	if($mybb->settings['mybbpublisher_enabled']==1 && $mythread['visible']==1 && $mybb->settings['mybbpublisher_onnewthread']==1)
	{
		//if posting from a draft, fid and tid not in post_insert_data, add it
		//also add tw and fb fields in case they are populated from some odd
		//workflow of the user/mods
		if($mythread['tid']=="" || $mythread['fid']=="")
		{
			$thread = get_thread( (int)$mybb->input['tid']);
			$mythread['tid'] = $thread['tid'];
			$mythread['fid'] = $thread['fid'];
			$mythread['fb_id'] = $thread['fb_id'];
			$mythread['fb_uid'] = $thread['fb_uid'];
			$mythread['tw_id'] = $thread['tw_id'];
		}
	
		if(mybbpublisher_can_do_publish($mythread['fid']))
		{
			$datafb = array();
			$datatw = array();
			
			//get URL of thread
			$url = $mybb->settings['bburl'] ."/" . get_thread_link($mythread['tid']);
	
			//make status text, apparently each service handles the subject differently
			$text_fb = stripslashes($mythread['subject']);
			$text_tw = htmlspecialchars_uni(stripslashes($mythread['subject']));
			
			$datafb[] = array(
				'type'=>'t',
				'id'=>$mythread['tid'],
				'msg' => $text_fb,
				'url' => $url,
				'postid'=>$mythread['fb_id'],
				'postuid'=>$mythread['fb_uid']
				);
				
			$datatw[] = array(
				'type'=>'t',
				'id'=>$mythread['tid'],
				'msg' => $text_tw,
				'url' => $url,
				'postid'=>$mythread['tw_id']
				);
			
			//do status updates
			mybbpublisher_fb_post_update($datafb);
			mybbpublisher_tw_post_update($datatw);
		}
	}
}

//handle delete threads
function mybbpublisher_delthread($tid) 
{
        global $mybb, $db;

	//get thread info
	$mythread = get_thread((int)$tid);

	if($mybb->settings['mybbpublisher_enabled']==1)
	{
		//do status updates
		if($mythread['fb_id'] != '')
		{
			$datafb = array();
			$datafb[] = array(
				'type'=>'t',
				'id'=>$mythread['tid'],
				'msg' => "",
				'url' => "",
				'postid'=>$mythread['fb_id'],
				'postuid'=>$mythread['fb_uid']
				);
				
			mybbpublisher_fb_post_update($datafb);
		}
		
		if($mythread['tw_id'] != '')
		{
			$datatw = array();
			$datatw[] = array(
				'type'=>'t',
				'id'=>$mythread['tid'],
				'msg' => "",
				'url' => "",
				'postid'=>$mythread['tw_id']
				);
				
			mybbpublisher_tw_post_update($datatw);
		}
	}
}

//handle edit threads
function mybbpublisher_editthread($threadbyref) 
{
        global $mybb, $db;

	if($mybb->settings['mybbpublisher_enabled']==1 && $mybb->settings['mybbpublisher_onnewthread']==1)
	{
		//since hook is by ref, put needed data into separate var
		$mythread = $threadbyref->thread_update_data;
		$mythread['tid'] =  (int)$threadbyref->tid;
	
		//add tw and fb fields
		$thread = get_thread( (int)$mythread['tid']);
		
		//these will be "0" if the thread had not yet been published
		$mythread['fb_id'] = $thread['fb_id'];
		$mythread['fb_uid'] = $thread['fb_uid'];
		$mythread['tw_id'] = $thread['tw_id'];
	
		//if using quick edit, subject is not supplied and thus will be empty and result in status being dropped
		if($mythread['subject'] == "")
		{
			$mythread['subject'] = $thread['subject'];
		}
		
		//force current FID
		$mythread['fid'] = $thread['fid'];
	
		//get URL of thread
		$url = $mybb->settings['bburl'] ."/" . get_thread_link($mythread['tid']);
	
		//make status text
		$text_fb = stripslashes($mythread['subject']);
		$text_tw = htmlspecialchars_uni(stripslashes($mythread['subject']));
		
		//unset publish data if thread edited is in forum that is no longer publishable
		//or if no longer visible so that it deletes the status update
		if(!mybbpublisher_can_do_publish($mythread['fid']) || $mythread['visible']!=1)
		{
			$text_fb = "";
			$text_tw = "";
			$url = "";
		}
			
		$datafb = array();
		$datafb[] = array(
			'type'=>'t',
			'id'=>$mythread['tid'],
			'msg' => $text_fb,
			'url' => $url,
			'postid'=>$mythread['fb_id'],
			'postuid'=>$mythread['fb_uid']
			);
		mybbpublisher_fb_post_update($datafb);
			
		$datatw = array();
		$datatw[] = array(
			'type'=>'t',
			'id'=>$mythread['tid'],
			'msg' => $text_tw,
			'url' => $url,
			'postid'=>$mythread['tw_id']
			);
			
		mybbpublisher_tw_post_update($datatw);
	}
}

//handle thread approvals
function mybbpublisher_approvethreads($tids) 
{
    global $mybb, $db;
    
	if($mybb->settings['mybbpublisher_enabled']==1 && $mybb->settings['mybbpublisher_onnewthread']==1 && count($tids) > 0)
	{
		foreach($tids as $tid)
		{
			//get thread info for current TID			
			$mythread = get_thread($tid);
			
			//get URL of thread
			$url = $mybb->settings['bburl'] ."/" . get_thread_link($mythread['tid']);
				
			//make status text
			$text_fb = stripslashes($mythread['subject']);
			$text_tw = htmlspecialchars_uni(stripslashes($mythread['subject']));
		
			//make sure visible and in publishable forum
			if(mybbpublisher_can_do_publish($mythread['fid']));// && $mythread['visible']==1)
			{
				//make sure not already published
				if($mythread['fb_id'] == 0)
				{
					if(!is_array($datafb))
					{
						$datafb = array();
					}
					$datafb[] = array(
						'type'=>'t',
						'id'=>$mythread['tid'],
						'msg' => $text_fb,
						'url' => $url,
						'postid'=>0,
						'postuid'=>0
						);
				}
			
				//make sure not already published
				if($mythread['tw_id'] == 0)
				{
					if(!is_array($datatw))
					{
						$datatw = array();
					}
					$datatw[] = array(
						'type'=>'t',
						'id'=>$mythread['tid'],
						'msg' => $text_tw,
						'url' => $url,
						'postid'=>0
						);
				}
			}
		}
	
		//send data
		if(is_array($datafb))
		{
			mybbpublisher_fb_post_update($datafb);
		}
		if(is_array($datatw))
		{
			mybbpublisher_tw_post_update($datatw);
		}
	}
}

//handle thread moves
function mybbpublisher_onmove($arguments)
{
        global $mybb;

	if($mybb->settings['mybbpublisher_enabled']==1 && $mybb->settings['mybbpublisher_onmove']==1)
	{
		//$arguments['new_fid'] only exists if single move from showthread inline moderation
		//$arguments['moveto'] only exists if multiple move from forumdispaly inline moderation
		//since moveto is still a single numeric fid value, go ahead and assign to new_fid so code can be reused
		//same with single move tid is single value, tids is array from multimove. create array to loop so code is simpler
		
		//handle multiple move from forumdisplay
		if(array_key_exists('moveto', $arguments))
		{
			$arguments['new_fid'] = $arguments['moveto'];
		}
		
		//handle single move from showthread
		if(array_key_exists('tid', $arguments))
		{
			$tids[] = $arguments['tid'];
			$arguments['tids'] = $tids;
		}
			
		$datafb = array();
		$datatw = array();
		
		//target forum publishable
		$can_do = mybbpublisher_can_do_publish($arguments['new_fid']);
		
		//loop through list of TIDs
		foreach($arguments['tids'] as $tid)
		{
			//make status text  
			$thread = get_thread($tid);
				
			//in case thread moved out of published forum or now not visible
			if($can_do && $thread['visible']==1)
			{
				//get URL of thread
				$url = $mybb->settings['bburl'] ."/" . get_thread_link($tid);
					
				//make status text
				$text_fb = stripslashes($thread['subject']);
				$text_tw = htmlspecialchars_uni(stripslashes($thread['subject']));
			
			}
			else
			{
				$url = "";
				$text_fb = "";
				$text_tw = "";
			}
				
			$datafb[] = array(
				'type'=>'t',
				'id'=>$tid,
				'msg' => $text_fb,
				'url' => $url,
				'postid'=>$thread['fb_id'],
				'postuid'=>$thread['fb_uid']
				);
				
			$datatw[] = array(
				'type'=>'t',
				'id'=>$tid,
				'msg' => $text_tw,
				'url' => $url,
				'postid'=>$thread['tw_id']
				);
		}
		
		//do status updates
		mybbpublisher_fb_post_update($datafb);
		mybbpublisher_tw_post_update($datatw);
	}
}


//handle new/edit announcements
function mybbpublisher_onannounce()
{
        global $db, $mybb, $aid;

	if($mybb->settings['mybbpublisher_enabled']==1 && $mybb->settings['mybbpublisher_onannounce']==1)
	{
		if($mybb->input['aid'] && $mybb->input['action'] == 'edit')
		{
			$aid =  (int)$mybb->input['aid'];
		}
		
		$datafb = array();
		$datatw = array();
		
		//get URL of thread
		$url = $mybb->settings['bburl'] ."/" . get_announcement_link($aid);
	
		//get announcement info 
		$query = $db->simple_select("announcements", "*", "aid=".$aid);
		$result = $db->fetch_array($query);
		$text_fb = stripslashes($result['subject']);
		$text_tw = htmlspecialchars_uni(stripslashes($result['subject']));
		
		//check if guest can view the announcement. global announcements posted regardless
		if($result['fid'] != -1)
		{
			if(!mybbpublisher_can_do_publish($result['fid']))
			{
				$text_fb = "";
				$text_tw = "";
			}
		}
		
		if($text_fb != "")
		{
			$datafb[] = array(
				'type'=>'a',
				'id'=>$aid,
				'msg' => $text_fb,
				'url' => $url,
				'postid'=>$result['fb_id'],
				'postuid'=>$result['fb_uid']
				);
			//edit status updates
			mybbpublisher_fb_post_update($datafb);
		}
		
		if($text_tw != "")
		{
			$datatw[] = array(
				'type'=>'a',
				'id'=>$aid,
				'msg' => $text_tw,
				'url' => $url,
				'postid'=>$result['tw_id']
				);
			
			//edit status updates
			mybbpublisher_tw_post_update($datatw);
		}
	}
}

//handle delete announcements
function mybbpublisher_delannounce()
{
        global $db, $mybb;

	if($mybb->settings['mybbpublisher_enabled']==1)
	{
		$datafb = array();
		$datatw = array();
		
		//get existing announcement info since hook called before actual announcement delete 
		$query = $db->simple_select("announcements", "*", "aid=". (int)$mybb->input['aid']);
		$result = $db->fetch_array($query);
		
		if($result['aid'])
		{
			if($result['fb_id'] != "" && $result['fb_id'] != "0")
			{
				$datafb = array();
				$datafb[] = array(
					'type'=>'a',
					'id'=>$result['aid'],
					'msg' => "",
					'url' => "",
					'postid'=>$result['fb_id'],
					'postuid'=>$result['fb_uid']
					);
					
				mybbpublisher_fb_post_update($datafb);
			}
		
			if($result['tw_id'] != "" && $result['tw_id'] != "0")
			{
				$datatw = array();
				$datatw[] = array(
					'type'=>'a',
					'id'=>$result['aid'],
					'msg' => "",
					'url' => "",
					'postid'=>$result['tw_id']
					);
					
				mybbpublisher_tw_post_update($datatw);
			}
		}
	}
}

//add icon to description if enabled
function mybbpublisher_addicon($forum) 
{
        global $mybb, $lang;

	if($mybb->settings['mybbpublisher_enabled']==1 && $mybb->settings['mybbpublisher_onnewthread']==1)
	{
		if(mybbpublisher_can_do_publish($forum['fid']))
		{
			$lang->load('mybbpublisher');
			if($mybb->settings['mybbpublisher_tw_enabled']==1 && $mybb->settings['mybbpublisher_tw_icon'] != "")
			{
				$forum['description'] = '<img src="'.$mybb->settings['mybbpublisher_tw_icon'].'" alt="'.$lang->mybbpublisher_tw_icon_alt.'"> '.$forum['description'];
			}
		
	
			if($mybb->settings['mybbpublisher_fb_enabled']==1 && $mybb->settings['mybbpublisher_fb_icon'] != "")
			{
				$forum['description'] = '<img src="'.$mybb->settings['mybbpublisher_fb_icon'].'" alt="'.$lang->mybbpublisher_fb_icon_alt.'"> '.$forum['description'];
			}
		}
	}
}


/****************************************************************
Twitter specific code
****************************************************************/

//do the actual update to the service
function mybbpublisher_tw_post_update($data)
{
	global $mybb, $db, $lang, $cache;
	
	if(is_array($data) && $mybb->settings['mybbpublisher_tw_enabled']==1 && $mybb->settings['mybbpublisher_tw_ckey'] != "" && $mybb->settings['mybbpublisher_tw_csecret'] != "" && $mybb->settings['mybbpublisher_tw_token'] != "" && $mybb->settings['mybbpublisher_tw_secret'] != "")
	{
		try {
			require_once MYBB_ROOT.'/inc/plugins/mybbpublisher/tmhOAuth.php';
			
			//setup for short URLs
			unset($bitly);
			unset($adfly);
			if($mybb->settings['mybbpublisher_shorten_user']  != "" && $mybb->settings['mybbpublisher_shorten_key'] != "" && $mybb->settings['mybbpublisher_shorten_tw'] == 1)
			{
				switch($mybb->settings['mybbpublisher_shorten_service'] )
				{
					case "bit":
						require_once MYBB_ROOT.'/inc/plugins/mybbpublisher/bitly.php';
						$bitly = new bitly($mybb->settings['mybbpublisher_shorten_user'], $mybb->settings['mybbpublisher_shorten_key']);
						break;
					
					case "adf":
						$adfly = 1;
						break;
				}
				
			}

			//create Twitter object using oAuth
			$tmhOAuth = new tmhOAuth(array(
				'consumer_key'    => $mybb->settings['mybbpublisher_tw_ckey'],
				'consumer_secret' => $mybb->settings['mybbpublisher_tw_csecret'],
				'user_token'      => $mybb->settings['mybbpublisher_tw_token'],
				'user_secret'     => $mybb->settings['mybbpublisher_tw_secret']
			));

			//twitter limits hourly queries, so test
			$tmhOAuth->request('GET', $tmhOAuth->url('1/account/rate_limit_status'));
			if ($tmhOAuth->response['code'] == 200) 
			{
				$limited = json_decode($tmhOAuth->response['response']);
			}
			
			//if no more hits avail, stop here
			if($limited->remaining_hits <= 0)
			{
				return false;
			}
			
			$counter == 0;
            $searchurl = '';
			foreach($data as $msg_url)
			{
				$msg = $msg_url['msg'];
				$url = $msg_url['url'];
				$id = $msg_url['id'];
				$type = $msg_url['type'];
				$postid = $msg_url['postid'];
				
				//shorten URLs
				if(isset($bitly) && $url != "")
				{
					$url = $bitly->shorten($url);
				}
				
				if(isset($adfly) && $url != "")
				{
					$url = get_adf_ly_url($url, $mybb->settings['mybbpublisher_shorten_user'], $mybb->settings['mybbpublisher_shorten_key']);
				}
				
				//delete existing update 
				if($postid != "" && $postid != "0")
				{
					$tmhOAuth->request('POST', $tmhOAuth->url('1/statuses/destroy/'.$postid));
					//will return $tmhOAuth->response['code'] == 200 if deleted
				}
				
				//post new update if msg supplied
				if($msg != "")
				{
					//build message, applying hashtags if specified
					if($mybb->settings['mybbpublisher_tw_hashlimit'] != 0 && $mybb->settings['mybbpublisher_tw_hashtags'] != "")
					{
						$hashtags = explode(",", $mybb->settings['mybbpublisher_tw_hashtags']);
						foreach($hashtags as $tag)
						{
							$origmsg = $msg;
							$msg = str_ireplace($tag, "#".$tag, $origmsg);
							if($origmsg != $msg)
							{
								$tagapplied++;
							}
							if($tagapplied == $mybb->settings['mybbpublisher_tw_hashlimit'])
							{
								continue;
							}
						}
					}
					
					//build message
					$lang->load('mybbpublisher');

					//get initial status update
					if($type == 'a')
					{
						$message = str_replace("{msg}", $msg, $lang->mybbpublisher_new_announce_tw);
						$message = str_replace("{urlbit}", ($url!="" ? $lang->mybbpublisher_at.$url."." : "."), $message);
					}
					else
					{
						$message = str_replace("{msg}", $msg, $lang->mybbpublisher_new_thread_tw);
						$message = str_replace("{urlbit}", ($url!="" ? $lang->mybbpublisher_at.$url."." : "."), $message);
					}
					
					//truncate $msg as needed, url already shortened if enabled
					if(strlen($message) > 140)
					{
						$over =  140-strlen($message) ; //returns negative number if mesasge > 140
						$msg = substr($msg, 0, $over); //uses neg number of drop the overage off the end of the message
						if($type == 'a')
						{
							$message = str_replace("{msg}", $msg, $lang->mybbpublisher_new_announce_tw);
							$message = str_replace("{urlbit}", ($url!="" ? $lang->mybbpublisher_at.$url."." : "."), $message);
						}
						else
						{
							$message = str_replace("{msg}", $msg, $lang->mybbpublisher_new_thread_tw);
							$message = str_replace("{urlbit}", ($url!="" ? $lang->mybbpublisher_at.$url."." : "."), $message);
						}
					}

					//status updates are not rate limited, do not increment counter
					$tmhOAuth->request('POST', $tmhOAuth->url('1/statuses/update'), array('status' => $message));					
						
					//if update accepted, record new IDs
					if($tmhOAuth->response['code'] == 200)
					{
						$status = json_decode($tmhOAuth->response['response']);
						
						if($type == 't')
						{
							$db->update_query('threads', array('tw_id'=>$status->id_str), 'tid='.$id);
						}
						else
						{
							$db->update_query('announcements', array('tw_id'=>$status->id_str), 'aid='.$id);
						}
					}
				}
				
				//we hit the hourly limit, quit handling additional threads/announcements in $data array
				if($counter == $limted->remaining_hits)
				{
					continue;
				}
			}
			
		} catch(Exception $e) {
		
			$errors = 'Date: ' . gmdate('r') . "\n";
			$errors .= "Forum ID: {$forum}\n";
			
			ob_start();
			var_dump($e);
			$errors .= ob_get_clean();
			$errors .= "\n\n===========================================\n\n";
				
			$cache->update('mybbpublisher_errors_tw', $errors);
			//die($e);
		}

	}
}


/****************************************************************
Facebook specific code
****************************************************************/


//do the actual update to the service
function mybbpublisher_fb_post_update($data)
{
	global $mybb,$db,$lang, $cache;
	
	if(is_array($data) && $mybb->settings['mybbpublisher_fb_enabled']==1 && $mybb->settings['mybbpublisher_fb_access_token_page'] != "")
	{	
			//setup for short URLs
			unset($bitly);
			unset($adfly);
			if($mybb->settings['mybbpublisher_shorten_user']  != "" && $mybb->settings['mybbpublisher_shorten_key'] != "" && $mybb->settings['mybbpublisher_shorten_fb'] == 1)
			{
				switch($mybb->settings['mybbpublisher_shorten_service'] )
				{
					case "bit":
						require_once MYBB_ROOT.'/inc/plugins/mybbpublisher/bitly.php';
						$bitly = new bitly($mybb->settings['mybbpublisher_shorten_user'], $mybb->settings['mybbpublisher_shorten_key']);
						break;
					
					case "adf":
						$adfly = 1;
						break;
				}
				
			}

			foreach($data as $msg_url)
			{
				$msg = $msg_url['msg'];
				$url = $msg_url['url'];
				$id = $msg_url['id'];
				$type = $msg_url['type'];
				$postid = $msg_url['postid'];
				$postuid = $msg_url['postuid'];
				
				//shorten URLs
				if(isset($bitly) && $url != "")
				{
					$url = $bitly->shorten($url);
				}
				
				if(isset($adfly) && $url != "")
				{
					$url = get_adf_ly_url($url, $mybb->settings['mybbpublisher_shorten_user'], $mybb->settings['mybbpublisher_shorten_key']);
				}
				

				//delete existing update
				if($postid != "" && $postid != "0")
				{
					$del_url = 'https://graph.facebook.com/'.$postid;
					$result = @file_get_contents($del_url.'?access_token='.$mybb->settings['mybbpublisher_fb_access_token_page'].'&method=delete');
					
					if($result != "true")
					{
						$cache->update('mybbpublisher_errors_fb', $result);
					}
				}
			
				//post new update if msg supplied
				if($msg != "")
				{
					$lang->load('mybbpublisher');
					//build message
					if($type == 'a')
					{
						//$message = "A new announcement, '".$msg."', has been posted to our forums".($url!="" ? " at: ".$url."." : ".");
						$message = str_replace("{msg}", $msg, $lang->mybbpublisher_new_announce_fb);
						$message = str_replace("{urlbit}", ($url!="" ? $lang->mybbpublisher_at.$url."." : "."), $message);
					}
					else
					{
						//$message = "A new announcement, '".$msg."', has been posted to our forums".($url!="" ? " at: ".$url."." : ".");
						$message = str_replace("{msg}", $msg, $lang->mybbpublisher_new_thread_fb);
						$message = str_replace("{urlbit}", ($url!="" ? $lang->mybbpublisher_at.$url."." : "."), $message);
					}
					
					//set page we are posting to
					$page_id = ($mybb->settings['mybbpublisher_fb_pageid'] != '' ? $mybb->settings['mybbpublisher_fb_pageid'] : 'me');
					$url = 'https://graph.facebook.com/'.$page_id.'/feed';
					
					$ch = curl_init();
					$attachment =  array('access_token'	=> $mybb->settings['mybbpublisher_fb_access_token_page'],                        
														'message'		=> $message,
														);
	
					curl_setopt($ch, CURLOPT_URL,$url);
					curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
					curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 2);
					curl_setopt($ch, CURLOPT_POST, true);
					curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
					curl_setopt($ch, CURLOPT_POSTFIELDS, $attachment);
					$result = curl_exec($ch);
					curl_close ($ch);
					
					$result = json_decode($result, true);
					
					if(array_key_exists('id', $result))
					{
						if($type == 't')
						{
							$db->update_query('threads', array('fb_id'=>$result['id'], 'fb_uid'=>$page_id), 'tid='.$id);
						}
						else
						{
							$db->update_query('announcements', array('fb_id'=>$result['id'], 'fb_uid'=>$page_id), 'aid='.$id);
						}
					}
					else
					{
						$cache->update('mybbpublisher_errors_fb', $result);
					}
					
				}	
			}
	}
}


//prompt user with link to MyBB Publisher setup/testing tool
function mybbpublisher_fb_prompt()
{
	global $mybb, $lang, $config;
	
    //init var
    $do_lang_update = false;
    
    //see if admin is changing a Facebook setting for MyBBPublisher
    if(is_array($mybb->input['upsetting']))
    {
        foreach($mybb->input['upsetting'] as $key=>$value)
        {
            if(stristr($key,'mybbpublisher_fb'))
            {
                $do_lang_update = true;
				continue;
            }
        }
    }
   
    //if editing mybbpublisher update status message to contine MyBB Publisher setup
    if($do_lang_update && $mybb->settings['mybbpublisher_fb_apikey'] != "" && $mybb->settings['mybbpublisher_fb_secret'] != "")
    {
		$add = '<br /><br />Jeśli po raz pierwszy zapisujesz ustawienia Facebooka w MyBBpublisher lub musisz zresetować uprawnienia twojej aplikacji na Facebooku, kilknij tu: <a href="'.$mybb->settings['bburl'].'/'.$config['admin_dir'].'/index.php?module=tools-mybbpublisher">Narzędzia MyBB Publishera</a>';
		
        $lang->success_setting_updated = $lang->success_setting_updated.$add;
		
        $lang->success_settings_updated = $lang->success_settings_updated.$add;        
    }
}

/****************************************************************
Admin tools testing code
****************************************************************/
function mybbpublisher_admin_nav(&$sub_menu)
{
	global $mybb, $lang;
	
		end($sub_menu);
		$key = (key($sub_menu))+20;
		
		if(!$key)
		{
			$key = '120';
		}
		
		$sub_menu[$key] = array('id' => 'mybbpublisher', 'title' => 'MyBB Publisher', 'link' => "index.php?module=tools-mybbpublisher");
}

function mybbpublisher_action_handler(&$action)
{
	$action['mybbpublisher'] = array('active' => 'mybbpublisher', 'file' => '');
}

function mybbpublisher_admin()
{
	global $mybb, $db, $page, $lang, $cache, $config;

	if($page->active_action == "mybbpublisher")
	{
		/****************************************************************
		Facebook corrections to input parameters so we know where we are
		****************************************************************/
		if($mybb->input['code']) //if code exists, user gave permission, insert needed inputs as FB wont return them
		{
			$mybb->input['action'] = 'verify_creds_fb';
			$mybb->input['do'] = 'from_facebook';
		}

		if($mybb->input['error_reason']) //user did not authorize
		{
			$mybb->input['action'] = 'verify_creds_fb';
			$mybb->input['do'] = 'from_facebook';
		}

		$page->add_breadcrumb_item("MyBB Publisher");
		$page->output_header("MyBB Publisher");

		$lang->load('mybbpublisher');
		
//verify required modules
		if(!function_exists('curl_init'))
		{
				echo '<h1><font color="red">'.$lang->mybbpublisher_curl.'</font></h1>';
		}

		if(!function_exists('json_decode'))
		{
				echo '<h1><font color="red">'.$lang->mybbpublisher_json.'</font></h1>';
		}

//output tests/setup
		if($mybb->settings['mybbpublisher_tw_ckey'] != "" && $mybb->settings['mybbpublisher_tw_csecret'] != "" && $mybb->settings['mybbpublisher_tw_token'] != "" && $mybb->settings['mybbpublisher_tw_secret'] != "")
		{
			echo '<h3>Twitter - test</h3>';
			echo 'Krok 1: <a href="index.php?module=tools-mybbpublisher&amp;action=verify_creds_tw">'.$lang->mybbpublisher_tw_step1.'</a><br />';
			echo 'Krok 2: <a href="index.php?module=tools-mybbpublisher&amp;action=rate_limit_tw">'.$lang->mybbpublisher_tw_step2.'</a><br />';
			echo 'Krok 3: <a href="index.php?module=tools-mybbpublisher&amp;action=recent_tw">'.$lang->mybbpublisher_tw_step3.'</a><br />';
		}
		else
		{
			echo '<h3>Twitter - test</h3>';
			echo $lang->mybbpublisher_tw_missing;
		}

		if($mybb->settings['mybbpublisher_fb_appid'] != "" && $mybb->settings['mybbpublisher_fb_secret'] != "")
		{
			echo '<h3>Facebook - test</h3>';
			echo 'Krok 1: <a href="index.php?module=tools-mybbpublisher&amp;action=verify_app_id_fb">'.$lang->mybbpublisher_fb_step1.'</a><br />';
			echo 'Krok 2: <a href="index.php?module=tools-mybbpublisher&amp;action=verify_creds_fb">'.$lang->mybbpublisher_fb_step2.'</a><br />';
			echo 'Krok 3: <a href="index.php?module=tools-mybbpublisher&amp;action=verify_creds_fb_page">'.$lang->mybbpublisher_fb_step3.'</a><br />';
			echo 'Krok 4: <a href="index.php?module=tools-mybbpublisher&amp;action=test_post_fb">'.$lang->mybbpublisher_fb_step4.'</a><br />';
		}
		else
		{
			echo '<h3>Facebook - test</h3>';
			echo $lang->mybbpublisher_fb_missing;
		}

//verify tw creds
		if($mybb->input['action'] == "verify_creds_tw")
		{
			echo '<h3>'.$lang->mybbpublisher_tw_step1_results.'</h3>';

			//create Twitter object using oAuth
			require_once MYBB_ROOT.'/inc/plugins/mybbpublisher/tmhOAuth.php';
			
			//obtain credentials
			try
			{

				$tmhOAuth = new tmhOAuth(array(
				  'consumer_key'    => $mybb->settings['mybbpublisher_tw_ckey'],
				  'consumer_secret' => $mybb->settings['mybbpublisher_tw_csecret'],
				  'user_token'      => $mybb->settings['mybbpublisher_tw_token'],
				  'user_secret'     => $mybb->settings['mybbpublisher_tw_secret']
				));

				$tmhOAuth->request('GET', $tmhOAuth->url('1/account/verify_credentials'));

				if ($tmhOAuth->response['code'] == 200) 
				{
					$tmhOAuth->pr(json_decode($tmhOAuth->response['response']));
				}
				else
				{
					$tmhOAuth->pr(htmlentities($tmhOAuth->response['response']));
				}			
			}
			catch(Exception $e) 
			{
				ob_start();
				var_dump($e);
				$errors = ob_get_clean();
				//echo $errors;
				echo '<pre>';
				print_r($errors);
				echo '</pre>';
			}
		}		

//check tw rate limit	
		if($mybb->input['action'] == "rate_limit_tw")
		{
			echo '<h3>'.$lang->mybbpublisher_tw_step2_results.'</h3>';
			//create Twitter object using oAuth
			require_once MYBB_ROOT.'/inc/plugins/mybbpublisher/tmhOAuth.php';
			
			//obtain credentials
			try
			{
				$tmhOAuth = new tmhOAuth(array(
				  'consumer_key'    => $mybb->settings['mybbpublisher_tw_ckey'],
				  'consumer_secret' => $mybb->settings['mybbpublisher_tw_csecret'],
				  'user_token'      => $mybb->settings['mybbpublisher_tw_token'],
				  'user_secret'     => $mybb->settings['mybbpublisher_tw_secret']
				));

				$tmhOAuth->request('GET', $tmhOAuth->url('1/account/rate_limit_status'));

				if ($tmhOAuth->response['code'] == 200) 
				{
					$tmhOAuth->pr(json_decode($tmhOAuth->response['response']));
				}
				else
				{
					$tmhOAuth->pr(htmlentities($tmhOAuth->response['response']));
				}			
			}
			catch(Exception $e) 
			{
				ob_start();
				var_dump($e);
				$errors = ob_get_clean();
				//echo $errors;
				echo '<pre>';
				print_r($errors);
				echo '</pre>';
			}
		}				

//test accessing account		
		if($mybb->input['action'] == "recent_tw")
		{
			echo '<h3>'.$lang->mybbpublisher_tw_step3_results.'</h3>';
			//create Twitter object using oAuth
			require_once MYBB_ROOT.'/inc/plugins/mybbpublisher/tmhOAuth.php';
			
			//obtain credentials
			try
			{
				$tmhOAuth = new tmhOAuth(array(
				  'consumer_key'    => $mybb->settings['mybbpublisher_tw_ckey'],
				  'consumer_secret' => $mybb->settings['mybbpublisher_tw_csecret'],
				  'user_token'      => $mybb->settings['mybbpublisher_tw_token'],
				  'user_secret'     => $mybb->settings['mybbpublisher_tw_secret']
				));

				$tmhOAuth->request('GET', $tmhOAuth->url('1/statuses/user_timeline'));

				if ($tmhOAuth->response['code'] == 200) 
				{
					$tmhOAuth->pr(json_decode($tmhOAuth->response['response']));
				}
				else
				{
					$tmhOAuth->pr(htmlentities($tmhOAuth->response['response']));
				}			
			}
			catch(Exception $e) 
			{
				ob_start();
				var_dump($e);
				$errors = ob_get_clean();
				//echo $errors;
				echo '<pre>';
				print_r($errors);
				echo '</pre>';
			}
		}				


//verify app id is valid
		if($mybb->input['action'] == "verify_app_id_fb")
		{
			echo '<h3>'.$lang->mybbpublisher_fb_step1_results.'</h3>';
			if($mybb->settings['mybbpublisher_fb_appid'] != "" && $mybb->settings['mybbpublisher_fb_secret'] != "")
			{	
				echo $lang->mybbpublisher_fb_appid_check.'<br /><br />';
				$fb_results = json_decode(@file_get_contents('http://graph.facebook.com/'.$mybb->settings['mybbpublisher_fb_appid']));
				
				echo 'Name: '.$fb_results->name.'<br />';
				echo 'Description: '.$fb_results->description.'<br />';
				echo 'Application Link: '.$fb_results->link.'<br />';
			}
			else
			{
				echo $lang->mybbpublisher_fb_missing2;
			}
		}

//verify personal account credentials
		if($mybb->input['action'] == "verify_creds_fb")
		{
			echo '<h3>'.$lang->mybbpublisher_fb_step2_results.'</h3>';
			if($mybb->settings['mybbpublisher_fb_appid'] != "" && $mybb->settings['mybbpublisher_fb_secret'] != "")
			{	
				//this is step two, return from permission request and hopefully have CODE
				if($mybb->input['do'] == 'from_facebook')
				{
					if($mybb->input['code']) //if code exists, user gave permission
					{
						$this_url = $mybb->settings['bburl'].'/'.$config['admin_dir'].'/index.php?module=tools-mybbpublisher';
						
						$fb_url = 'https://graph.facebook.com/oauth/access_token?client_id='.$mybb->settings['mybbpublisher_fb_appid'].'&redirect_uri='.urlencode($this_url).'&client_secret='.$mybb->settings['mybbpublisher_fb_secret'].'&code='.$mybb->input['code'];

						//since we have code, get access token
						$fb_results = @file_get_contents($fb_url);
						
						
						echo $lang->mybbpublisher_fb_token_success.'<br /><br />';
						echo $fb_results;
						echo '<br /><br />'.$lang->mybbpublisher_fb_token_saved.'<br /><br />';
						
						$fb_results = str_ireplace('access_token=', '', $fb_results);
						$setting = array(
							"value" => $fb_results
						);

						$db->update_query("settings", $setting, "name='mybbpublisher_fb_access_token'");
						rebuild_settings();
					}
					elseif($mybb->input['error_reason']) //else user denied 
					{
						echo 'Error reason: '.$mybb->input['error_reason'].'<br />';
						echo 'Error description: '.$mybb->input['error_description'].'<br />';
					}
					else
					{
						echo $lang->mybbpublisher_fb_error;
					}
				}
			
				//this is step one, request permissions and get CODE
				else
				{
					$this_url = $mybb->settings['bburl'].'/'.$config['admin_dir'].'/index.php?module=tools-mybbpublisher';
				
					$fb_url = 'https://www.facebook.com/dialog/oauth?client_id='.$mybb->settings['mybbpublisher_fb_appid'].'&redirect_uri='.urlencode($this_url).'&scope=manage_pages,publish_stream,read_stream,offline_access';
					
					//redirect to facebook
					echo '<script type="text/javascript">
					<!--
					window.location = "'.$fb_url.'"
					//-->
					</script>';
				
				}
			}
			else
			{
				echo $lang->mybbpublisher_fb_missing2;
			}
		}				

//figure out the who and where of publishing
		if($mybb->input['action'] == "verify_creds_fb_page")
		{
			if($mybb->settings['mybbpublisher_fb_appid'] != "" && $mybb->settings['mybbpublisher_fb_secret'] != "")
			{	
				//this is step two, replace the access
				if((int)$mybb->input['step'] == 2)
				{
					echo '<h3>'.$lang->mybbpublisher_fb_step3_results.'</h3>';
					
					if(isset($mybb->input['id'])) //posting to page/group/app
					{
						if(isset($mybb->input['access_token'])) //as page/group/app
						{
							$access_token = $mybb->input['access_token'];
						}
						else //as you
						{
							$access_token = $mybb->settings['mybbpublisher_fb_access_token'];
						}
						
						$post_to_id = $mybb->input['id'];
					}
					//posting to own wall as yourself
					else 
					{
						$access_token = $mybb->settings['mybbpublisher_fb_access_token'];
						$post_to_id = '';
					}	
					
					//update where to post
					$db->update_query("settings", array("value" => $post_to_id), "name='mybbpublisher_fb_pageid'");

					//update token used to post
					$db->update_query("settings", array("value" => $access_token), "name='mybbpublisher_fb_access_token_page'");
					
					rebuild_settings();
					
					echo $lang->mybbpublisher_fb_manage_success;
				}
			
				//this is step one, get and list accounts user can manage
				else
				{
					echo '<h3>'.$lang->mybbpublisher_fb_step3.'</h3><br />';

					$fb_url = 'https://graph.facebook.com/me?access_token='.$mybb->settings['mybbpublisher_fb_access_token'];

					//since we have code, get access token
					$fb_me = json_decode(@file_get_contents($fb_url));
					
					$next_url = $mybb->settings['bburl'].'/'.$config['admin_dir'].'/index.php?module=tools-mybbpublisher&action=verify_creds_fb_page&step=2';
					
					$fb_url = 'https://graph.facebook.com/me/accounts?access_token='.$mybb->settings['mybbpublisher_fb_access_token'];

					//since we have code, get access token
					$fb_results = json_decode(@file_get_contents($fb_url));
					
					if(is_array($fb_results->data))
					{
						foreach($fb_results->data as $account)
						{
							echo 'Name: '.$account->name . ' -- ID: ' .$account->id;
							echo '<br /><a href="'.$next_url.'&id='.$account->id.'&access_token='.$account->access_token.'">Post to '.$account->name.' as '.$account->name.'</a>';
							echo '<br /><a href="'.$next_url.'&id='.$account->id.'">Post to '.$account->name.' as '.$fb_me->name.'</a>';
							echo '<br /><br />';
						}
					}
					else
					{
						echo '<br />'.$lang->mybbpublisher_no_manage;
						echo '<br /><br />';
					}
					echo $lang->mybbpublisher_label_own;
					echo '<br /><a href="'.$next_url.'">Post as '.$fb_me->name.' to your own wall.</a>';
					
				}
			}
			else
			{
				echo $lang->mybbpublisher_fb_missing2;
			}			
		}				

//test post to FB
		if($mybb->input['action'] == "test_post_fb")
		{
			
			echo '<h3>'.$lang->mybbpublisher_fb_step4_results.'</h3>';
			
			if($mybb->input['do'] == "delete")
			{
				$url = 'https://graph.facebook.com/'.$mybb->input['fb_id'];
				$result = @file_get_contents($url.'?access_token='.$mybb->settings['mybbpublisher_fb_access_token_page'].'&method=delete');
				$result = json_decode($result);

				echo $lang->mybbpublisher_fb_test_return.'<br />';
				if(!$result->error)
				{
					echo $lang->mybbpublisher_fb_test_success.$result;
				}
				else
				{
					echo $lang->mybbpublisher_fb_test_failed.$result->error->message;
				}
				
			}
			else
			{
				
				//set page we are posting to
				$page_id = ($mybb->settings['mybbpublisher_fb_pageid'] != '' ? $mybb->settings['mybbpublisher_fb_pageid'] : 'me');
				$url = 'https://graph.facebook.com/'.$page_id.'/feed';
				
				$ch = curl_init();
				$attachment =  array('access_token'	=> $mybb->settings['mybbpublisher_fb_access_token_page'],                        
													'message'		=> 'This is a test of the newly activated MyBB Publisher plugin',
													);

				curl_setopt($ch, CURLOPT_URL,$url);
				curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
				curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 2);
				curl_setopt($ch, CURLOPT_POST, true);
				curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
				curl_setopt($ch, CURLOPT_POSTFIELDS, $attachment);
				$result = curl_exec($ch);
				curl_close ($ch);
				
				$testout = json_decode($result);

				echo $lang->mybbpublisher_fb_test_return.'<br />';
				echo '<pre>';
				print_r($testout);
				echo '</pre>';
				
				if($testout->id == "" || !isset($testout->id))
				{
					echo $lang->mybbpublisher_fb_test_failed2;
				}
				else
				{
					echo '<br />'.$lang->mybbpublisher_fb_test_made.'<a href="'.$mybb->settings['bburl'].'/'.$config['admin_dir'].'/index.php?module=tools-mybbpublisher&action=test_post_fb&do=delete&fb_id='.$testout->id.'">'.$lang->mybbpublisher_fb_test_delete.'</a>';
				}
			}
		}				

		$page->output_footer();
	}
}

/****************************************************************
Adf.ly shortening function
****************************************************************/
function get_adf_ly_url($url,$uid,$apikey,$domain="adf.ly")
{
		global $mybb;
		
        $adfurl = "http://api.adf.ly/api.php?key=".$apikey."&uid=".$uid."&advert_type=int&domain=".$domain."&url=".$url;

        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $adfurl);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_REFERER, $mybb->settings['homeurl']);
        $short_url = curl_exec($ch);
        curl_close($ch);
        
        return $short_url;
}
?>
